using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MySql.Data.MySqlClient;


namespace lr3
{
    public partial class Form16 : Form
    {
        public void disable_components(Control[] c) //блокує пакетно передані візуальні компоненти
        {
            foreach (Control e in c) e.Enabled = false; //перебираємо через змінну e компоненти та блокуємо їх
        }

        public void enable_components(Control[] c) //розблоковує пакетно передані компоненти
        {
            foreach (Control e in c) e.Enabled = true; //перебираємо через змінну e компоненти та розблоковуємо їх
        }

        public void hide_components(Control[] c) //ховаємо пакетно передані компоненти
        {
            foreach (Control e in c) e.Visible = false;//перебираємо через змінну е компоненти та ховаємо їх
        }

        public void show_components(Control[] c) //показуємо пакетно передані компоненти
        {
            foreach (Control e in c) e.Visible = true;//перебираємо через змінну е компоненти та показуємо їх
        }

        public bool alert_message(string msg, string cap) //показує повідомлення і повертає істину, якщо натиснута кнопка так
        {
            //показуємо повідомлення msg із заголовком cap і якщо відповідь так тоді повертаемо істину
            if (MessageBox.Show(msg, cap, MessageBoxButtons.YesNo) == DialogResult.Yes) return true;
            return false;//в іншому випадку повертаємо хибність
        }
        static string cs = new MySqlConnectionStringBuilder()
        {
            UserID = "root",
            Password = "Stryb1972@@@",
            Database = "trybushynina",
            Server = "localhost"
        }.ConnectionString;

        private void fill_grid(string q, DataGridView d, string[] f, string[] wn, string[] nn)
        { //Виконуємо запит і відображаємо результат на сітці та ховаємо у відображенні стовпці f
            //та переіменовуємо стовпці wn в nn
            fill_grid(q, d, f); // викликаємо перевантажену функцію яка заповнює сітку та ховає "непотрібні" поля
            for (int i = 0; i <= wn.Length - 1; i++)
            { //перебираємо кожне значення в wn
                d.Columns[wn[i]].HeaderText = nn[i];//присвоюємо стовпцю з назвою елемента wn нову назву з nn
            }

        }

        //=-=-=-=-=-=-=-= Перше перевантаження функції (тільки приховуємо)
        private void fill_grid(string q, DataGridView d, string[] f)
        { //Виконуємо запит і відображаємо результат на сітці та ховаємо у відображенні стовпці f
            fill_grid(q, d);//викликаємо перевантажену функцію, яка заповнює сітку
            foreach (string fn in f) //перебераємо всі значення f
            {
                d.Columns[fn].Visible = false;//ховаємо заданий стовпець
            }
        }

        public MySqlConnection con = new MySqlConnection(cs);
        public Form16(MySqlConnection c)
        {
            InitializeComponent();
            con = c;
            fill_grid("SELECT * FROM `providers`;", dataGridView1,

                new string[] { "id" },//перелічуємо назви стовпців, які потрібно приховати
                new string[] { "Name", "phone", "address", "Email", "EDRPOU", "IPN" },//перелічуємо назви стовпців транслітом
                new string[] { "Ім'я",  "Телефон", "Адреса", "Електронна пошта", "ЄДРПОУ", "ІПН" });
        }
        private void fill_grid(string q, DataGridView d)
        {
            DataTable dt = new DataTable();
            if (con.State.ToString() != "Open") con.Open();
            MySqlCommand com = new MySqlCommand(q, con);
            MySqlDataReader dr = com.ExecuteReader();
            dt.Load(dr);
            d.DataSource = dt;
            dr.Close();
        }

        private void run_query(string q)
        {
            if (con.State.ToString() != "Open") con.Open();
            MySqlCommand com = new MySqlCommand(q, con);
            com.ExecuteNonQuery();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            string s = textBox1.Text + "";
            fill_grid("SELECT * FROM `providers` WHERE `Name` LIKE '%" + s + "%';", dataGridView1,
                new string[] { "id" },//перелічуємо назви стовпців, які потрібно приховати
                new string[] { "Name",  "phone", "address", "Email", "EDRPOU", "IPN" },//перелічуємо назви стовпців транслітом
                new string[] { "Ім'я",  "Телефон", "Адреса", "Електронна пошта", "ЄДРПОУ", "ІПН" });
        }

        private void button1_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            string s = textBox2.Text + "";
            fill_grid("SELECT * FROM `providers` WHERE `phone` LIKE '%" + s + "%';", dataGridView1,
                new string[] { "id" },//перелічуємо назви стовпців, які потрібно приховати
                new string[] { "Name",  "phone", "address", "Email", "EDRPOU", "IPN" },//перелічуємо назви стовпців транслітом
                new string[] { "Ім'я",  "Телефон", "Адреса", "Електронна пошта", "ЄДРПОУ", "ІПН" });
        }

        private void button2_Click(object sender, EventArgs e)
        {
            textBox2.Text = "";
        }

        private void button3_Click(object sender, EventArgs e)
        {
            string name = textBox3.Text + "";
            string phone = textBox4.Text + "";
           
            string address = textBox7.Text + "";
            string Email = textBox8.Text + "";
            string EDRPOU = textBox5.Text + "";
            string IPN = textBox6.Text + "";
            run_query("INSERT INTO `providers` VALUES (NULL,'" + name + "','"  + phone + "','" + address + "','" + Email + "','" + EDRPOU + "','" + IPN + "');");
            fill_grid("SELECT * FROM `providers`;", dataGridView1,
                new string[] { "id" },//перелічуємо назви стовпців, які потрібно приховати
                new string[] { "Name", "phone", "address", "Email", "EDRPOU", "IPN" },//перелічуємо назви стовпців транслітом
                new string[] { "Ім'я",  "Телефон", "Адреса", "Електронна пошта", "ЄДРПОУ", "ІПН" });
            textBox3.Text = ""; textBox4.Text = "";  textBox7.Text = ""; textBox8.Text = ""; textBox5.Text = ""; textBox6.Text = "";
            button4_Click(this, null);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            string name = textBox10.Text; string phone = textBox11.Text; string address = textBox13.Text; string Email = textBox9.Text; string EDRPOU = textBox12.Text; string IPN = textBox14.Text;
            string id = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["id"].Value + "";
          
            run_query("UPDATE `providers` SET `Name`='" + name + "',`phone`='" + phone + "',`address`='" + address + "',`Email`='" + Email + "',`EDRPOU`='" + EDRPOU + "',`IPN`='" + IPN + "' WHERE `id`=" + id + ";");
            fill_grid("SELECT * FROM `providers`;", dataGridView1,
                new string[] { "id" },//перелічуємо назви стовпців, які потрібно приховати
                new string[] { "Name",  "phone", "address", "Email", "EDRPOU", "IPN" },//перелічуємо назви стовпців транслітом
                new string[] { "Ім'я", "Телефон", "Адреса", "Електронна пошта", "ЄДРПОУ", "ІПН" });
            button6_Click(this, null);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            textBox10.Text = ""; textBox11.Text = "";  textBox13.Text = ""; textBox9.Text = ""; textBox12.Text = ""; textBox14.Text = "";
            tabControl1.SelectedIndex = 0;//перемикаємо на вкладку додати
            enable_components(new Control[] { dataGridView1, tabPage1, tabPage2, textBox1, textBox2 });//розблоковуємо сітку, вкладку редагувати і панель пошуку
            hide_components(new Control[] { tabControl1 });//ховаємо панель вкладок
        }

        private void видалитиToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string id = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells[0].Value + "";
            string name = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["Name"].Value + "";
            if ((id != "") && (alert_message("Ви дійсно бажаєте видалити запис " + name + " ?", "Питання")))
            {
                run_query("DELETE FROM `providers` WHERE `id`=" + id + ";");
                fill_grid("SELECT * FROM `providers`;", dataGridView1,
                    new string[] { "id" },//перелічуємо назви стовпців, які потрібно приховати
                new string[] { "Name",  "phone", "address", "Email", "EDRPOU", "IPN" },//перелічуємо назви стовпців транслітом
                new string[] { "Ім'я",  "Телефон", "Адреса", "Електронна пошта", "ЄДРПОУ", "ІПН" });
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            enable_components(new Control[] { dataGridView1, tabPage2, textBox1, textBox2 });//розблоковуємо сітку, вкладку редагувати і панель пошуку
            hide_components(new Control[] { tabControl1 });//ховаємо панель вкладок
        }

        private void редагуватиToolStripMenuItem_Click(object sender, EventArgs e)
        {
            textBox10.Text = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["Name"].Value + "";
            textBox11.Text = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["phone"].Value + "";
            
            textBox13.Text = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["address"].Value + "";
            textBox9.Text = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["Email"].Value + "";
            textBox12.Text = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["EDRPOU"].Value + "";
            textBox14.Text = dataGridView1.Rows[dataGridView1.CurrentRow.Index].Cells["IPN"].Value + "";
            show_components(new Control[] { tabControl1, button6 }); //(1)
            disable_components(new Control[] { dataGridView1, textBox1, textBox2, tabPage1 });//(2)
            tabControl1.SelectedIndex = 1;
        }

        private void додатиToolStripMenuItem_Click(object sender, EventArgs e)
        {
            show_components(new Control[] { tabControl1, tabPage1, button6 });//показуємо панель вкладок, та кнопку відмінити редагування
            disable_components(new Control[] { dataGridView1, tabPage2, textBox1, textBox2 });//блокуємо сітку, вкладку редагувати, панель пошуку
        }
    }
}
